Index: src/Parser/TypeData.cc
===================================================================
--- src/Parser/TypeData.cc	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ src/Parser/TypeData.cc	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -322,5 +322,5 @@
 			function.params->printList( os, indent + 4 );
 		} else {
-			os << string( indent + 2, ' ' ) << "with no parameters " << endl;
+			os << string( indent + 2, ' ' ) << "with no parameters" << endl;
 		} // if
 		if ( function.idList ) {
@@ -347,17 +347,17 @@
 		os << DeclarationNode::aggregateNames[ aggregate.kind ] << ' ' << *aggregate.name << endl;
 		if ( aggregate.params ) {
-			os << string( indent + 2, ' ' ) << "with type parameters " << endl;
+			os << string( indent + 2, ' ' ) << "with type parameters" << endl;
 			aggregate.params->printList( os, indent + 4 );
 		} // if
 		if ( aggregate.actuals ) {
-			os << string( indent + 2, ' ' ) << "instantiated with actual parameters " << endl;
+			os << string( indent + 2, ' ' ) << "instantiated with actual parameters" << endl;
 			aggregate.actuals->printList( os, indent + 4 );
 		} // if
 		if ( aggregate.fields ) {
-			os << string( indent + 2, ' ' ) << "with members " << endl;
+			os << string( indent + 2, ' ' ) << "with members" << endl;
 			aggregate.fields->printList( os, indent + 4 );
 		} // if
 		if ( aggregate.body ) {
-			os << string( indent + 2, ' ' ) << " with body " << endl;
+			os << string( indent + 2, ' ' ) << " with body" << endl;
 		} // if
 		break;
@@ -370,5 +370,5 @@
 		} // if
 		if ( aggInst.params ) {
-			os << string( indent + 2, ' ' ) << "with parameters " << endl;
+			os << string( indent + 2, ' ' ) << "with parameters" << endl;
 			aggInst.params->printList( os, indent + 2 );
 		} // if
@@ -381,5 +381,5 @@
 		} // if
 		if ( enumeration.body ) {
-			os << string( indent + 2, ' ' ) << " with body " << endl;
+			os << string( indent + 2, ' ' ) << " with body" << endl;
 		} // if
 		break;
@@ -418,5 +418,5 @@
 		os << "tuple ";
 		if ( tuple ) {
-			os << "with members " << endl;
+			os << "with members" << endl;
 			tuple->printList( os, indent + 2 );
 		} // if
@@ -942,5 +942,5 @@
 	assert( td->typeexpr );
 	// assert( td->typeexpr->expr );
-	return new TypeofType{ 
+	return new TypeofType{
 		buildQualifiers( td ), td->typeexpr->build(), td->kind == TypeData::Basetypeof };
 } // buildTypeof
Index: src/SynTree/Expression.cc
===================================================================
--- src/SynTree/Expression.cc	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ src/SynTree/Expression.cc	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -456,8 +456,8 @@
 
 void UntypedExpr::print( std::ostream &os, Indenter indent ) const {
-	os << "Applying untyped: " << std::endl;
+	os << "Applying untyped:" << std::endl;
 	os << indent+1;
 	function->print(os, indent+1);
-	os << std::endl << indent << "...to: " << std::endl;
+	os << std::endl << indent << "...to:" << std::endl;
 	printAll(args, os, indent+1);
 	Expression::print( os, indent );
Index: src/SynTree/ReferenceToType.cc
===================================================================
--- src/SynTree/ReferenceToType.cc	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ src/SynTree/ReferenceToType.cc	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -205,5 +205,5 @@
 
 	Type::print( os, indent );
-	os << "instance of " << typeString() << " " << get_name() << " (" << ( isFtype ? "" : "not" ) << " function type) ";
+	os << "instance of " << typeString() << " " << get_name() << " (" << ( isFtype ? "" : "not" ) << " function type)";
 	if ( ! parameters.empty() ) {
 		os << endl << indent << "... with parameters" << endl;
Index: src/SynTree/Type.cc
===================================================================
--- src/SynTree/Type.cc	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ src/SynTree/Type.cc	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -118,5 +118,5 @@
 
 void QualifiedType::print( std::ostream & os, Indenter indent ) const {
-	os << "Qualified Type: " << endl;
+	os << "Qualified Type:" << endl;
 	os << indent+1;
 	parent->print( os, indent+1 );
Index: tests/.expect/alloc-ERROR.txt
===================================================================
--- tests/.expect/alloc-ERROR.txt	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ tests/.expect/alloc-ERROR.txt	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -1,17 +1,17 @@
-alloc.cfa:265:1 error: No reasonable alternatives for expression Applying untyped: 
+alloc.cfa:265:1 error: No reasonable alternatives for expression Applying untyped:
   Name: ?=?
-...to: 
+...to:
   Name: p
-  Applying untyped: 
+  Applying untyped:
     Name: realloc
-  ...to: 
+  ...to:
     Name: stp
-    Applying untyped: 
+    Applying untyped:
       Name: ?*?
-    ...to: 
+    ...to:
       Name: dim
-      Sizeof Expression on: Applying untyped: 
+      Sizeof Expression on: Applying untyped:
           Name: *?
-        ...to: 
+        ...to:
           Name: stp
 
@@ -19,19 +19,19 @@
 
 
-alloc.cfa:266:1 error: No reasonable alternatives for expression Applying untyped: 
+alloc.cfa:266:1 error: No reasonable alternatives for expression Applying untyped:
   Name: ?=?
-...to: 
+...to:
   Name: p
-  Applying untyped: 
+  Applying untyped:
     Name: alloc
-  ...to: 
+  ...to:
     Name: stp
-    Applying untyped: 
+    Applying untyped:
       Name: ?*?
-    ...to: 
+    ...to:
       Name: dim
-      Sizeof Expression on: Applying untyped: 
+      Sizeof Expression on: Applying untyped:
           Name: *?
-        ...to: 
+        ...to:
           Name: stp
 
@@ -39,22 +39,22 @@
 
 
-alloc.cfa:267:1 error: No reasonable alternatives for expression Applying untyped: 
+alloc.cfa:267:1 error: No reasonable alternatives for expression Applying untyped:
   Name: ?=?
-...to: 
+...to:
   Name: p
-  Applying untyped: 
+  Applying untyped:
     Name: memset
-  ...to: 
+  ...to:
     Name: stp
     constant expression (10 10: signed int)
 
 
-alloc.cfa:268:1 error: No reasonable alternatives for expression Applying untyped: 
+alloc.cfa:268:1 error: No reasonable alternatives for expression Applying untyped:
   Name: ?=?
-...to: 
+...to:
   Name: p
-  Applying untyped: 
+  Applying untyped:
     Name: memcpy
-  ...to: 
+  ...to:
     Address of:
       Name: st1
Index: tests/.expect/completeTypeError.txt
===================================================================
--- tests/.expect/completeTypeError.txt	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ tests/.expect/completeTypeError.txt	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -1,92 +1,45 @@
-completeTypeError.cfa:33:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:33:1 error: No reasonable alternatives for expression Applying untyped:
   Name: *?
-...to: 
+...to:
   Name: v
 
-completeTypeError.cfa:34:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:34:1 error: No reasonable alternatives for expression Applying untyped:
   Name: *?
-...to: 
+...to:
   Name: y
 
-completeTypeError.cfa:35:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:35:1 error: No reasonable alternatives for expression Applying untyped:
   Name: foo
-...to: 
+...to:
   Name: v
 
-completeTypeError.cfa:36:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:36:1 error: No reasonable alternatives for expression Applying untyped:
   Name: baz
-...to: 
+...to:
   Name: v
 
-completeTypeError.cfa:37:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:37:1 error: No reasonable alternatives for expression Applying untyped:
   Name: quux
-...to: 
+...to:
   Name: v
 
-completeTypeError.cfa:58:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:58:1 error: No reasonable alternatives for expression Applying untyped:
   Name: baz
-...to: 
+...to:
   Name: y
 
-completeTypeError.cfa:59:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:59:1 error: No reasonable alternatives for expression Applying untyped:
   Name: quux
-...to: 
+...to:
   Name: y
 
-completeTypeError.cfa:60:1 error: No reasonable alternatives for expression Applying untyped: 
+completeTypeError.cfa:60:1 error: No reasonable alternatives for expression Applying untyped:
   Name: *?
-...to: 
+...to:
   Name: y
 
-completeTypeError.cfa:72:1 error: No resolvable alternatives for expression Applying untyped: 
+completeTypeError.cfa:72:1 error: No reasonable alternatives for expression Applying untyped:
   Name: baz
-...to: 
+...to:
   Name: z
 
-Alternatives with failing assertions are:
-Cost ( 0, 1, 0, 1, -5, 0 ): Application of
-     Variable Expression: baz: forall
-       T: sized object type
-       ... with assertions
-         ?=?: pointer to function
-         ... with parameters
-           reference to instance of type T (not function type) 
-           instance of type T (not function type) 
-         ... returning
-           _retval__operator_assign: instance of type T (not function type) 
-           ... with attributes:
-             Attribute with name: unused
-
-
-         ?{}: pointer to function
-         ... with parameters
-           reference to instance of type T (not function type) 
-         ... returning nothing
-
-         ?{}: pointer to function
-         ... with parameters
-           reference to instance of type T (not function type) 
-           instance of type T (not function type) 
-         ... returning nothing
-
-         ^?{}: pointer to function
-         ... with parameters
-           reference to instance of type T (not function type) 
-         ... returning nothing
-
-
-       function
-     ... with parameters
-       pointer to instance of type T (not function type) 
-     ... returning nothing
-
-   ... to arguments
-     Variable Expression: z: pointer to instance of type T (not function type) 
-
- (types:
-   void 
- )
- Environment:( _73_0_T ) -> instance of type T (not function type)  (no widening)
-
-
-
Index: tests/.expect/declarationErrors.txt
===================================================================
--- tests/.expect/declarationErrors.txt	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ tests/.expect/declarationErrors.txt	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -6,13 +6,13 @@
 
 declarationErrors.cfa:19:1 error: duplicate static in declaration of x4: static const volatile instance of const volatile struct __anonymous0
-  with members 
+  with members
     i: int 
-   with body 
+   with body
 
 
 declarationErrors.cfa:20:1 error: duplicate const, duplicate static, duplicate volatile in declaration of x5: static const volatile instance of const volatile struct __anonymous1
-  with members 
+  with members
     i: int 
-   with body 
+   with body
 
 
@@ -20,50 +20,50 @@
 
 declarationErrors.cfa:24:1 error: duplicate const in declaration of f01: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:25:1 error: duplicate volatile in declaration of f02: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:26:1 error: duplicate const in declaration of f03: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:27:1 error: duplicate volatile in declaration of f04: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:28:1 error: duplicate const in declaration of f05: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:29:1 error: duplicate volatile in declaration of f06: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:30:1 error: duplicate const in declaration of f07: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:31:1 error: duplicate const, duplicate volatile in declaration of f08: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:33:1 error: duplicate const, duplicate volatile in declaration of f09: static inline function
-  with no parameters 
+  with no parameters
   returning const volatile int 
 
 
 declarationErrors.cfa:34:1 error: duplicate const, duplicate _Atomic, duplicate _Atomic, duplicate const, duplicate restrict, duplicate volatile in declaration of f09: static inline function
-  with no parameters 
+  with no parameters
   returning const restrict volatile _Atomic int 
 
Index: tests/.expect/nested-types-ERR2.txt
===================================================================
--- tests/.expect/nested-types-ERR2.txt	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ tests/.expect/nested-types-ERR2.txt	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -1,6 +1,6 @@
 nested-types.cfa:73:1 error: Use of undefined global type Z
 nested-types.cfa:74:1 error: Qualified type requires an aggregate on the left, but has: signed int
-nested-types.cfa:75:1 error: Undefined type in qualified type: Qualified Type: 
+nested-types.cfa:75:1 error: Undefined type in qualified type: Qualified Type:
   instance of struct S with body 1
-  instance of type Z (not function type) 
+  instance of type Z (not function type)
 
Index: tests/concurrent/examples/datingService.cfa
===================================================================
--- tests/concurrent/examples/datingService.cfa	(revision 52ffa30aa99274381f3378ddebbe6301748191ef)
+++ tests/concurrent/examples/datingService.cfa	(revision 276a55b2c9291e54685e980e0483fef56ee12b7c)
@@ -33,4 +33,5 @@
 		signal_block( Boys[ccode] );					// restart boy to set phone number
 	} // if
+	sout | "Girl:" | PhoneNo | "is dating Boy at" | BoyPhoneNo | "with ccode" | ccode;
 	return BoyPhoneNo;
 } // DatingService girl
@@ -44,4 +45,5 @@
 		signal_block( Girls[ccode] );					// restart girl to set phone number
 	} // if
+	sout | " Boy:" | PhoneNo | "is dating Girl" | GirlPhoneNo | "with ccode" | ccode;
 	return GirlPhoneNo;
 } // DatingService boy
@@ -58,5 +60,4 @@
 	yield( random( 100 ) );								// don't all start at the same time
 	unsigned int partner = girl( TheExchange, id, ccode );
-	sout | "Girl:" | id | "is dating Boy at" | partner | "with ccode" | ccode;
 	girlck[id] = partner;
 } // Girl main
@@ -76,5 +77,4 @@
 	yield( random( 100 ) );								// don't all start at the same time
 	unsigned int partner = boy( TheExchange, id, ccode );
-	sout | " Boy:" | id | "is dating Girl" | partner | "with ccode" | ccode;
 	boyck[id] = partner;
 } // Boy main