Index: tests/unified_locking/.expect/block_spin_lock.txt
===================================================================
--- tests/unified_locking/.expect/block_spin_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/.expect/block_spin_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,3 @@
+Starting
+Done!
+Match!
Index: tests/unified_locking/.expect/clh.txt
===================================================================
--- tests/unified_locking/.expect/clh.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/.expect/clh.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,3 @@
+Starting
+Done!
+Match!
Index: tests/unified_locking/.expect/mcs_block_spin_lock.txt
===================================================================
--- tests/unified_locking/.expect/mcs_block_spin_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/.expect/mcs_block_spin_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,3 @@
+Starting
+Done!
+Match!
Index: tests/unified_locking/.expect/simple_owner_lock.txt
===================================================================
--- tests/unified_locking/.expect/simple_owner_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/.expect/simple_owner_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,3 @@
+Starting
+Done!
+Match!
Index: tests/unified_locking/.expect/spin_queue_lock.txt
===================================================================
--- tests/unified_locking/.expect/spin_queue_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/.expect/spin_queue_lock.txt	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,3 @@
+Starting
+Done!
+Match!
Index: tests/unified_locking/block_spin_lock.cfa
===================================================================
--- tests/unified_locking/block_spin_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/block_spin_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,8 @@
+#include <locks.hfa>
+
+#define LOCK block_spin_lock
+#include "mutex_test.hfa"
+
+int main() {
+    test();
+}
Index: tests/unified_locking/clh.cfa
===================================================================
--- tests/unified_locking/clh.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/clh.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,8 @@
+#include <locks.hfa>
+
+#define LOCK clh_lock
+#include "mutex_test.hfa"
+
+int main() {
+    test();
+}
Index: tests/unified_locking/mcs_block_spin_lock.cfa
===================================================================
--- tests/unified_locking/mcs_block_spin_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/mcs_block_spin_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,8 @@
+#include <locks.hfa>
+
+#define LOCK mcs_block_spin_lock
+#include "mutex_test.hfa"
+
+int main() {
+    test();
+}
Index: tests/unified_locking/simple_owner_lock.cfa
===================================================================
--- tests/unified_locking/simple_owner_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/simple_owner_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,8 @@
+#include <locks.hfa>
+
+#define LOCK simple_owner_lock
+#include "mutex_test.hfa"
+
+int main() {
+    test();
+}
Index: tests/unified_locking/spin_queue_lock.cfa
===================================================================
--- tests/unified_locking/spin_queue_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
+++ tests/unified_locking/spin_queue_lock.cfa	(revision 305aaefa257af19c1447306fa40fd1b53be531b6)
@@ -0,0 +1,8 @@
+#include <locks.hfa>
+
+#define LOCK spin_queue_lock
+#include "mutex_test.hfa"
+
+int main() {
+    test();
+}