Index: tests/attributes.cfa
===================================================================
--- tests/attributes.cfa	(revision 77148b08d37e54e1e2289ee68f8928d6326cb3bd)
+++ tests/attributes.cfa	(revision 372d33c9ab2b3d7bb943b4093d09a48a99b9032a)
@@ -1,10 +1,10 @@
-// 
+//
 // Cforall Version 1.0.0 Copyright (C) 2017 University of Waterloo
 //
 // The contents of this file are covered under the licence agreement in the
 // file "LICENCE" distributed with Cforall.
-// 
-// attributes.cfa -- 
-// 
+//
+// attributes.cfa --
+//
 // Author           : Peter A. Buhr
 // Created On       : Mon Feb  6 16:07:02 2017
@@ -12,10 +12,12 @@
 // Last Modified On : Fri Dec 20 15:32:21 2024
 // Update Count     : 53
-// 
+//
 
+#pragma GCC diagnostic ignored "-Wattributes"
 
 // label attribute
 int la() {
   L: __attribute__(( unused )) 1;
+  return 1;
 }
 
@@ -64,20 +66,20 @@
 // function_declarator
 __attribute__(( unused )) int f1() __attribute__(( used ));
-__attribute__(( unused )) int f1() {}
+__attribute__(( unused )) int f1() { return 1; }
 __attribute__(( unused )) int * __attribute__(( unused )) * const __attribute__(( unused )) f2() __attribute__(( used ));
-__attribute__(( unused )) int * __attribute__(( unused )) * const __attribute__(( unused )) f2() {}
+__attribute__(( unused )) int * __attribute__(( unused )) * const __attribute__(( unused )) f2() { return 0p; }
 __attribute__(( unused )) int (* __attribute__(( unused )) f3(int))[] __attribute__(( used ));
 __attribute__(( unused )) int ( __attribute__(( unused )) * __attribute__(( unused )) f4(int))[] __attribute__(( used ));
-__attribute__(( unused )) int (* __attribute__(( unused )) f5(int p))[] {}
-__attribute__(( unused )) int ( __attribute__(( unused )) * (f6)(int p))[] {}
+__attribute__(( unused )) int (* __attribute__(( unused )) f5(int p))[] { (void)p; return 0p; }
+__attribute__(( unused )) int ( __attribute__(( unused )) * (f6)(int p))[] { (void)p; return 0p; }
 __attribute__(( unused )) int (* __attribute__(( unused )) f7())(int) __attribute__(( used ));
-__attribute__(( unused )) int (* __attribute__(( unused )) f8())(int) {}
-__attribute__(( unused )) int ( __attribute__(( unused )) * f9())(int) {}
-__attribute__(( unused )) int ( __attribute__(( unused )) * (f10)())(int) {}
+__attribute__(( unused )) int (* __attribute__(( unused )) f8())(int) { return 0p; }
+__attribute__(( unused )) int ( __attribute__(( unused )) * f9())(int) { return 0p; }
+__attribute__(( unused )) int ( __attribute__(( unused )) * (f10)())(int) { return 0p; }
 
 
 // variable_type_redeclarator
 typedef int t1, t2, t3, t4, t5, t6, t7, t8;
-int vtr() {
+void vtr() {
     // redefine typedef name in new scope
     __attribute__(( unused )) int __attribute__(( unused )) t1 __attribute__(( used ));
@@ -92,19 +94,19 @@
 
 // identifier_parameter_declarator
-int ipd1( __attribute__(( unused )) int __attribute__(( unused )) p __attribute__(( unused )),
+void ipd1( __attribute__(( unused )) int __attribute__(( unused )) p __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) q __attribute__(( unused )) );
-int ipd1( __attribute__(( unused )) int __attribute__(( unused )) p __attribute__(( unused )),
+void ipd1( __attribute__(( unused )) int __attribute__(( unused )) p __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) q __attribute__(( unused )) ) {}
-int ipd2( __attribute__(( unused )) int __attribute__(( unused )) * __attribute__(( unused )) p __attribute__(( unused )),
+void ipd2( __attribute__(( unused )) int __attribute__(( unused )) * __attribute__(( unused )) p __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) (* (q)) __attribute__(( unused )) );
-int ipd2( __attribute__(( unused )) int __attribute__(( unused )) * __attribute__(( unused )) p __attribute__(( unused )),
+void ipd2( __attribute__(( unused )) int __attribute__(( unused )) * __attribute__(( unused )) p __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) (* (q)) __attribute__(( unused )) ) {}
-int ipd3( __attribute__(( unused )) int __attribute__(( unused )) p[] __attribute__(( unused )),
+void ipd3( __attribute__(( unused )) int __attribute__(( unused )) p[] __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) ((q)[]) __attribute__(( unused )) );
-int ipd3( __attribute__(( unused )) int __attribute__(( unused )) p[] __attribute__(( unused )),
+void ipd3( __attribute__(( unused )) int __attribute__(( unused )) p[] __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) ((q)[]) __attribute__(( unused )) ) {}
-int ipd4( __attribute__(( unused )) int __attribute__(( unused )) p() __attribute__(( unused )),
+void ipd4( __attribute__(( unused )) int __attribute__(( unused )) p() __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) ((q)()) __attribute__(( unused )) );
-int ipd4( __attribute__(( unused )) int __attribute__(( unused )) p() __attribute__(( unused )),
+void ipd4( __attribute__(( unused )) int __attribute__(( unused )) p() __attribute__(( unused )),
 	  __attribute__(( unused )) int __attribute__(( unused )) ((q)()) __attribute__(( unused )) ) {}
 
@@ -122,5 +124,5 @@
 
 // abstract_declarator
-int ad() {
+void ad() {
     typeof( int __attribute__(( used )) ) ad1 __attribute__(( unused ));
     typeof( int __attribute__(( unused )) * __attribute__(( unused )) ) ad2 __attribute__(( unused ));
@@ -157,5 +159,5 @@
 // variable_abstract_declarator
 struct Vad {
-    int __attribute__(( unused ));
+    int __attribute__(( unused )) x;
     int __attribute__(( unused )) :4;
     int __attribute__(( unused )) :4, __attribute__(( unused )) :6;
@@ -174,8 +176,9 @@
 		3;
 	}
+	abort();
 }
 
 @[ noreturn ] void mary() {
-	@[aligned(64)] struct S { int i; };
+	@[aligned(16)] struct S { int i; };
 	int @[unused] i;
 	switch ( 3 ) {
@@ -187,4 +190,5 @@
 		3;
 	}
+	abort();
 }
 